# __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory > Class Template Reference

Inheritance diagram for __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >:

List of all members.

## Detailed Description

### template<typename Iterator1, typename Iterator2, typename IteratorCategory>
class __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >

A pair of iterators. The usual iterator operations are applied to both child iterators.

Definition at line 50 of file iterator.h.

## Public Types

- typedef traits_type::difference_type difference_type
- typedef Iterator1 first_type
- typedef IteratorCategory iterator_category
- typedef type * pointer
- typedef type & reference
- typedef Iterator2 second_type
- typedef std::iterator_traits<
  Iterator1 > traits_type
- typedef void value_type

## Public Member Functions

- iterator_pair (const Iterator1 &first, const Iterator2 &second)
- iterator_pair ()
- operator Iterator2 () const
- type operator+ (difference_type delta) const
- const type operator++ (int)
- type & operator++ ()
- difference_type operator- (const type &other) const
- const type operator-- (int)
- type & operator-- ()
- type & operator= (const type &other)

## Public Attributes

- Iterator1 first
- Iterator2 second

## Member Typedef Documentation

typedef Iterator1 std::pair< Iterator1 , Iterator2 >::first_type `[inherited]`

`first_type` is the first bound type

Definition at line 74 of file stl_pair.h.

typedef Iterator2 std::pair< Iterator1 , Iterator2 >::second_type `[inherited]`

`second_type` is the second bound type

Definition at line 75 of file stl_pair.h.

## Member Data Documentation

Iterator1 std::pair< Iterator1 , Iterator2 >::first `[inherited]`

`first` is a copy of the first object

Definition at line 77 of file stl_pair.h.

Referenced by __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator+(), __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator++(), __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator-(), __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator--(), and __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator=().

Iterator2 std::pair< Iterator1 , Iterator2 >::second `[inherited]`

`second` is a copy of the second object

Definition at line 78 of file stl_pair.h.

Referenced by __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator Iterator2(), __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator+(), __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator++(), __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator--(), and __gnu_parallel::iterator_pair< Iterator1, Iterator2, IteratorCategory >::operator=().

The documentation for this class was generated from the following file:

- iterator.h